#!/usr/bin/env python3.0
#-*- coding:Utf-8 -*-

from    netCDF4               import    Dataset
from    scipy.ndimage.filters                import	gaussian_filter1d
from    scipy.ndimage.filters                import	convolve1d
from    scipy.ndimage.filters                import	uniform_filter1d
from    numpy import *
import  numpy                 as        np
import  matplotlib.pyplot     as        mpl
import  math
from    math import log
from    matplotlib.colors import LogNorm
import  pylab
corrk_dir = 'pluton_ch4var_COfix/'


g = loadtxt(corrk_dir+'g.dat',skiprows=1)

data_VI = loadtxt(corrk_dir+'17x23/corrk_gcm_VI.dat')
wn_VI = loadtxt(corrk_dir+'17x23/narrowbands_VI.in',skiprows=1)

data_IR = loadtxt(corrk_dir+'17x23/corrk_gcm_IR.dat')
wn_IR = loadtxt(corrk_dir+'17x23/narrowbands_IR.in',skiprows=1)

band_VI=23 # Number of VIS bands
band_IR=17 # Number of IR bands

ngauss=33 # Number of gauss points
temp=8 # Number of temperature points
pres=7 # Number of pressure points
x_vmr=7 # Number of mixing ratio points

corrk_VI=np.zeros((temp,pres,x_vmr,band_VI,ngauss),dtype='f')
corrk_IR=np.zeros((temp,pres,x_vmr,band_IR,ngauss),dtype='f')


count=0
for i in range(0,ngauss,1):
    for j in range(0,band_VI,1):
        for k in range(0,x_vmr,1):
            for l in range(0,pres,1):
                for m in range(0,temp,1):
                    corrk_VI[m,l,k,j,i]=data_VI[count]
                    count=count+1

count=0
for i in range(0,ngauss,1):
    for j in range(0,band_IR,1):
        for k in range(0,x_vmr,1):
            for l in range(0,pres,1):
                for m in range(0,temp,1):
                    corrk_IR[m,l,k,j,i]=data_IR[count]
                    count=count+1

g_cum=np.zeros(len(g),dtype='f')

g_cum[0]=g[0]
for i in range(1,len(g),1):
    g_cum[i]=g_cum[i-1]+g[i]

print (g, g_cum)

wn_mean_VI=np.zeros(len(wn_VI),dtype='f')
for i in range(0,len(wn_VI),1):
    wn_mean_VI[i]=(wn_VI[i,0]+wn_VI[i,1])/2.

wn_mean_IR=np.zeros(len(wn_IR),dtype='f')
for i in range(0,len(wn_IR),1):
    wn_mean_IR[i]=(wn_IR[i,0]+wn_IR[i,1])/2.

print (wn_mean_VI)
print (wn_mean_IR)

corrk_mean_VI=np.zeros((temp,pres,x_vmr,band_VI),dtype='f')
corrk_mean_IR=np.zeros((temp,pres,x_vmr,band_IR),dtype='f')

for i in range(0,temp,1):
    for j in range(0,pres,1):
        for k in range(0,x_vmr,1):
            for l in range(0,band_VI,1):
                for m in range(0,ngauss,1):
                    corrk_mean_VI[i,j,k,l]=corrk_mean_VI[i,j,k,l]+corrk_VI[i,j,k,l,m]*g[m]

for i in range(0,temp,1):
    for j in range(0,pres,1):
        for k in range(0,x_vmr,1):
            for l in range(0,band_IR,1):
                for m in range(0,ngauss,1):
                    corrk_mean_IR[i,j,k,l]=corrk_mean_IR[i,j,k,l]+corrk_IR[i,j,k,l,m]*g[m]

%matplotlib widget
from ipywidgets import *

mpl.figure(1)
mpl.ylabel('absorption', fontsize=15)
mpl.xlabel('wavelength', fontsize=15)

# HERE YOU CHANGE THE INDICES TO PLOT ANY GIVEN TEMPERATURE,PRESSURE,VMR POINT OF THE OPACITY TABLE
# TO GET THE CORRESPONDANCE BETWEEN INDEX and P,T,VMR values, please check T.dat, P.dat, Q.dat, and eventually composition.in

itemp=5 # from 0 to 7 --> temperature points
ipres=4 # from 0 to 6 --> pressure points
ivmr=2 # from 0 to 6 --> mixing ratio points

mpl.semilogy(10000./wn_mean_VI,corrk_mean_VI[itemp,ipres,ivmr,:],color='blue',label='VIS')
mpl.semilogy(10000./wn_mean_IR,corrk_mean_IR[itemp,ipres,ivmr,:],'--',color='purple',label='IR')

mpl.loglog()

mpl.legend()
mpl.show()
